static int validchan(char *chan)
{
  struct chanset_t *ch;

#ifndef OLDBOT
  ch = findchan_by_dname(chan);
#else
  ch = findchan(chan);
#endif
  if (ch)
    return 1;
  return 0;
}

static int msg_top10 (char *nick, char *uhost, struct userrec *u, char *rest)
{
  char *chan;
  
  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: top10 <chan>\n", nick);
    return 1;
  }
  tell_top(chan, nick, rest, 1, 10, 0);
  return 1;
}

static int msg_ttop10 (char *nick, char *uhost, struct userrec *u, char *rest)
{
  char *chan;
  
  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: ttop10 <chan>\n", nick);
    return 1;
  }
  tell_top(chan, nick, rest, 1, 10, 1);
  return 1;
}

static int msg_top20 (char *nick, char *uhost, struct userrec *u, char *rest)
{
  char *chan;
  
  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: top20 <chan>\n", nick);
    return 1;
  }
  tell_top(chan, nick, rest, 11, 20, 0);
  return 1;
}

static int msg_ttop20 (char *nick, char *uhost, struct userrec *u, char *rest)
{
  char *chan;
  
  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: ttop10 <chan>\n", nick);
    return 1;
  }
  tell_top(chan, nick, rest, 11, 20, 1);
  return 1;
}

static int msg_place(char *nick, char *host, struct userrec *u,
        char *rest)
{
  char *chan;


  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: place <chan>\n", nick);
    return 1;
  }
  tell_place(nick, nick, u->handle, chan, rest, S_TOTAL);
  Context;
  return 1;
}

static int msg_tplace(char *nick, char *host, struct userrec *u,
        char *rest)
{
  char *chan;

  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: tplace <chan>\n", nick);
    return 1;
  }
  tell_place(nick, nick, u->handle, chan, rest, S_TODAY);
  Context;
  return 1;
}

static int msg_stat(char *nick, char *host, struct userrec *u,
        char *rest)
{
  char *chan;

  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: stat <chan> [user]\n", nick);
    return 1;
  }
  tell_stat(nick, nick, u->handle, chan, rest, S_TOTAL);
  Context;
  return 1;
}

static int msg_tstat(char *nick, char *host, struct userrec *u,
        char *rest)
{
  char *chan;

  chan = newsplit(&rest);
  if (!validchan(chan)) {
    dprintf(DP_HELP, "PRIVMSG %s :Sorry, that is not a valid channel. Usage: tstat <chan> [user]\n", nick);
    return 1;
  }
  tell_stat(nick, nick, u->handle, chan, rest, S_TODAY);
  Context;
  return 1;
}

static cmd_t stats_msg[] =
{
  {"top10", "", msg_top10, 0},
  {"ttop10", "", msg_ttop10, 0},
  {"top20", "", msg_top20, 0},
  {"ttop20", "", msg_ttop20, 0},
  {"place", "", msg_place, 0},
  {"tplace", "", msg_tplace, 0},
  {"stat", "", msg_stat, 0},
  {"tstat", "", msg_tstat, 0},
  {0, 0, 0, 0}
};
